;; -*- mode: common-lisp; package: lcl -*-
;;
;; run-lcl.cl
;;
;; copyright (c) 1986-1998 Franz Inc, Berkeley, CA
;; All rights reserved.
;;
;; Permission is granted only to any individual or institution which has
;; current Allegro CL license(s) for a UNIX platform from Franz Inc.,
;; to use, copy, or modify this software, provided that this
;; complete copyright and permission notice is maintained, intact, in
;; all copies and supporting documentation. 
;;
;; Franz Incorporated provides this software "as is" without
;; express or implied warranty.
;;
;; Restricted Rights Legend
;; ------------------------
;; Use, duplication, and disclosure of the software, data and information
;; contained herein by any agency, department or entity of the U.S.
;; Government are subject to restrictions of Restricted Rights for
;; Commercial Software developed at private expense as specified in FAR
;; 52.227-19 or DOD FAR Supplement 252 52.227-7013 (c) (1) (ii), as
;; applicable.


;;; Functions and Macros that provide Lucid Common Lisp
;;; facilities in the Allegro CL run-time environment.
;;;
;;; An application file that needs these facilities
;;; should include (USE-PACKAGE "LCL") or its equivalent.


;;;  3-Oct-94 mm: insert new import-export file
;;;  4-Oct-94 mm: first pass at callbacak code seems to work
;;;  5-Oct-94 mm: callbacks now return values correctly
;;;  6-Oct-94 mm: add foreign type and struct stuff
;;;  9-Oct-94 mm: finish foreign type propagation
;;; 12-Oct-94 mm: close tbi list
;;; 13-Oct-94 mm: revise pointer type managment
;;; 14-Oct-94 mm: add foreign-type-size
;;;               add and use *INITIALIZE-FOREIGN-STRUCTS*
;;; 15-Oct-94 mm: fix some mp bugs,   insert new import-export
;;; 18-Oct-94 mm: workaround bug in mp:symeval-in-stack-group
;;; 26-Oct-94 mm: begin 1.02 -- allow type nil in convert-return-type
;;; 12-Nov-94 mm: begin 1.03 -- add resource functions 
;;; 16-Nov-94 mm: fix DEF-FOREIGN-STRUCT in overlay case
;;; 29-Apr-95 mm: begin 1.04
;;;                   add CHANGE-MEMORY-MANAGEMENT
;;;                   *LOAD-BINARY-PATHNAME-TYPES*
;;;                   *ENTER-TOP-LEVEL-HOOK*
;;;                   FOREIGN-VALUE and FOREIGN-SIZE-OF, also *SAFER-CODE*
;;;               allow NIL in convert-callback-return-type
;;;               allow user-defined types in convert-foreign-type
;;;                     also, improve double-float handling
;;;               try to do more in LOAD-FOREIGN-FILES in SVR4 case
;;;               allow (ignored) filter-function arg in MAKE-RESOURCE
;;;               make directory arg optional in CD
;;;               try to decode struct accessors in FOREIGN-AREF
;;;               in DEF-FOREIGN-SYNONYM-TYPE, force def in foreign space
;;;               add AREF-SF and VAR-FOREIGN-AREF
;;;               refine decode-array-accessor for character arrays
;;;               refine typed-foreign-aref
;;; <17> mm  5-Jun-96: begin 1.05 - changes for 4.3
;;; <18> 23-Feb-98 mm: begin 1.06 - changes for 5.0


(defpackage "LCL")
(in-package "LCL")
(eval-when (compile eval)
  (excl:set-case-mode :case-insensitive-upper)    ;; <17>
  )

#-ALLEGRO
(eval-when (compile load eval)
  (error "This file runs only in Allegro Common Lisp."))

(defvar *ltoa-version* "LtoA Version 1.06")

(defpackage "LCL"
  (:use "COMMON-LISP" "CLTL1")
  (:nicknames "LUCID-COMMON-LISP" "LUCID" "LTOA" "LUCID-TO-ALLEGRO")

  (:import-from "MP" "GLOBAL-SYMBOL-VALUE")    ;; <17>
  
;;(Begin insertion of scan-lcl-data.import-export

;;             This file generated 14-Nov-1994 13:44
;; from scan-lcl-data.master dated 14-Nov-1994 13:38

  ;; Lucid package was LCL, def: Bound
  (:import-from "MULTIPROCESSING" "*ALL-PROCESSES*")

  ;; Lucid package was SYS, def: Bound
  (:import-from "EXCL" "*CLOS-PACKAGE*")

  ;; Lucid package was LCL, def: Bound
  (:import-from "MULTIPROCESSING" "*CURRENT-PROCESS*")

  ;; Lucid package was SYS, def: Bound
  (:import-from "EXCL" "*KEYWORD-PACKAGE*")

  ;; Lucid package was SYS, def: Bound
  (:import-from "EXCL" "*LISP-PACKAGE*")

  ;; Lucid package was LCL, def: Bound
  (:import-from "EXCL" "*PRINT-STRUCTURE*")

  ;; Lucid package was LCL, def: NIL
  (:import-from "TOP-LEVEL" "*PROMPT*")

  ;; Lucid package was LCL, def: Bound
  (:import-from "EXCL" "*SOURCE-PATHNAME*")

  ;; Lucid package was SYS, def: Bound
  (:import-from "EXCL" "*SYSTEM-PACKAGE*")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "ARGLIST")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "ASSQ")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "BIGNUMP")

  ;; Lucid package was LCL, def: NIL
  (:import-from "EXCL" "CASE-FAILURE")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "FIXNUMP")

  ;; Lucid package was LCL, def: NIL
  (:import-from "FOREIGN-FUNCTIONS" "FOREIGN-POINTER")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "MEMQ")

  ;; Lucid package was LCL, def: NIL
  (:import-from "MULTIPROCESSING" "PROCESS")

  ;; Lucid package was LCL, def: Func
  (:import-from "MULTIPROCESSING" "PROCESS-ALLOW-SCHEDULE")

  ;; Lucid package was LCL, def: Func
  (:import-from "MULTIPROCESSING" "PROCESS-NAME")

  ;; Lucid package was LCL, def: Func
  (:import-from "MULTIPROCESSING" "PROCESS-WAIT-FUNCTION")

  ;; Lucid package was LCL, def: Func
  (:import-from "MULTIPROCESSING" "PROCESS-WHOSTATE")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "RATIOP")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "SHELL")

  ;; Lucid package was LCL, def: Func
  (:import-from "EXCL" "UNCOMPILE")

  (:EXPORT "%POINTER" "*&" "*ALL-PROCESSES*" "*CLOS-PACKAGE*"
   "*COMMON-LISP-PACKAGE*" "*CURRENT-PROCESS*" "*DEFAULT-FOREIGN-LIBRARIES*"
   "*KEYWORD-PACKAGE*" "*LISP-PACKAGE*"
   "*LISP-SYMBOL-TO-FOREIGN-STRING-METHOD*" "*PRINT-STRUCTURE*" "*PROMPT*"
   "*SOURCE-PATHNAME*" "*SYSTEM-PACKAGE*" "+&" "-&" "/=&" "1+&" "1-&" "<&"
   "<=&" "=&" ">&" ">=&" "ABS&" "ACTIVATE-PROCESS" "ARGLIST" "ASH&" "ASSQ"
   "BIGNUMP" "BOOLE&" "BYTE-SPECIFIER" "BYTE-SPECIFIER-P" "C-STRING-TYPE"
   "CASE-FAILURE" "CD" "CEILING&" "CHECK-STACK-REMAINING" "CLEAR-RESOURCE"
   "CLOSE-ALL-FILES" "COMMAND-LINE-ARGUMENT" "COMPILE-ALL-DISPATCH-CODE"
   "COPY-FOREIGN-POINTER" "DEACTIVATE-PROCESS" "DECACHE-EVAL" "DECF&"
   "DEF-COMPILER-MACRO" "DEF-FOREIGN-CALLABLE" "DEF-FOREIGN-FUNCTION"
   "DEF-FOREIGN-STRUCT" "DEF-FOREIGN-SUBST" "DEF-FOREIGN-SYNONYM-TYPE"
   "DEFINE-COMPILER-SUBST" "DEFINE-FUNCTION" "DEFINE-MACRO"
   "DEFINED-FOREIGN-TYPE-P" "DEFSUBST" "DELETE-DEFSTRUCT" "DELQ"
   "DEPOSIT-BYTE" "DEPOSIT-BYTE&" "DEPOSIT-FIELD&" "DISABLE-STACK-LISTS"
   "DO-PRESENT-SYMBOLS" "DPB&" "EGC-OFF" "EGC-ON" "EGC-OPTIONS" "EGC-STATE"
   "ENABLE-STACK-LISTS" "ENVIRONMENT-VARIABLE" "EPHEMERAL-GC" "EQL&" "EVENP&"
   "FAST-READ-BYTE" "FAST-READ-CHAR" "FAST-UNREAD-CHAR" "FAST-WRITE-BYTE"
   "FAST-WRITE-CHAR" "FAST-WRITE-STRING" "FIXNUMP" "FLOOR&" "FOREIGN-AREF"
   "FOREIGN-POINTER" "FOREIGN-POINTER-ADDRESS" "FOREIGN-POINTER-P"
   "FOREIGN-POINTER-TYPE" "FOREIGN-STRING-VALUE" "FOREIGN-TYPE-SIZE"
   "FOREIGN-VARIABLE-ADDRESS" "FOREIGN-VARIABLE-P" "FOREIGN-VARIABLE-POINTER"
   "FREE-FOREIGN-POINTER" "GC" "GC-OFF" "GC-ON" "GC-SIZE" "GCD&"
   "GET-STACK-REMAINING" "IGNORE" "INCF&" "INTEGER-LENGTH&"
   "INTERRUPT-PROCESS" "KILL-PROCESS" "LDB&" "LET-GLOBALLY" "LISP-IMAGE-NAME"
   "LIST-NREVERSE" "LIST-REVERSE" "LOAD-BYTE" "LOAD-FOREIGN-FILES"
   "LOAD-FOREIGN-LIBRARIES" "LOAD-PATCHES" "LOGAND&" "LOGANDC1&" "LOGANDC2&"
   "LOGBITP&" "LOGCOUNT&" "LOGIOR&" "LOGNAND&" "LOGNOR&" "LOGNOT&" "LOGORC1&"
   "LOGORC2&" "LOGTEST&" "LOGXOR&" "MAKE-FOREIGN-POINTER" "MAKE-PROCESS"
   "MAKE-RESOURCE" "MALLOC-FOREIGN-POINTER" "MASK-FIELD&" "MAX&" "MEMQ" "MIN&"
   "MINUSP&" "MOD&" "ODDP&" "PARSE-BODY" "PATHNAME-LESSP" "PLUSP&"
   "PRECOMPILE-GENERIC-FUNCTIONS" "PROCESS" "PROCESS-ACTIVE-P"
   "PROCESS-ALIVE-P" "PROCESS-ALLOW-SCHEDULE" "PROCESS-INITIAL-ARGUMENTS"
   "PROCESS-INITIAL-FUNCTION" "PROCESS-INTERRUPTIONS" "PROCESS-LOCK"
   "PROCESS-NAME" "PROCESS-PLIST" "PROCESS-STATE" "PROCESS-UNLOCK"
   "PROCESS-WAIT" "PROCESS-WAIT-ARGUMENTS" "PROCESS-WAIT-FOREVER"
   "PROCESS-WAIT-FUNCTION" "PROCESS-WAIT-WITH-TIMEOUT" "PROCESS-WHOSTATE"
   "PROCESSP" "PWD" "QUIT" "RATIOP" "READ-ARRAY" "REHASH" "REM&"
   "REPORT-COMPILER-OPTIONS" "RESET-COMPILER-OPTIONS" "RESOURCE-ALLOCATE"
   "RESOURCE-DEALLOCATE" "RESTART-PROCESS" "ROUND&" "RUN-PROGRAM" "SEQUENCEP"
   "SHELL" "SHOW-PROCESSES" "SIMPLE-ARRAY-P" "SIMPLE-BASE-STRING-P"
   "SIMPLE-STRING-LENGTH" "STATIONARY-OBJECT-P" "STRING-OUTPUT-STREAM-P"
   "SYMBOL-DYNAMICALLY-BOUNDP" "SYMBOL-GLOBAL-BOUNDP" "SYMBOL-GLOBAL-VALUE"
   "SYMBOL-PROCESS-BOUNDP" "SYMBOL-PROCESS-VALUE" "TRUNCATE&"
   "TYPED-FOREIGN-AREF" "UNCOMPILE" "UNDEFINE-FOREIGN-TYPE"
   "UNINTERN-FOREIGN-SYMBOL" "USING-INITIAL-IO" "USING-RESOURCE"
   "WITH-BUFFERED-TERMINAL-OUTPUT" "WITH-COMPILER-OPTIONS"
   "WITH-DEFERRED-WARNINGS" "WITH-INTERRUPTIONS-ALLOWED"
   "WITH-INTERRUPTIONS-INHIBITED" "WITH-INTERRUPTS-DEFERRED"
   "WITH-NORMAL-CONSING-AREA" "WITH-PROCESS-LOCK" "WITH-SCHEDULING-ALLOWED"
   "WITH-SCHEDULING-INHIBITED" "WITH-STATIC-AREA" "WORKING-DIRECTORY"
   "WRITABLE-OBJECT-P" "WRITE-ARRAY" "XOR" "ZEROP&")

;; End insertion)
  
  ;; Additional exports done manually

  (:export
   
   "*ENTER-TOP-LEVEL-HOOK*"
   "*FOREIGN-CALLBACK-HANDLES*"
   "*FOREIGN-CALLBACK-INIT-SUFFIX*"
   "*FOREIGN-CALLBACK-CALL-SUFFIX*"
   "*INITIALIZE-FOREIGN-STRUCTS*"
   "*LOAD-BINARY-PATHNAME-TYPES*"
   "*LTOA-VERBOSE-NOOP*"
   "*LUCID-CALLBACK-FIXUPS*"
   "*PROTOTYPED-C-FUNDECLS*"
   "*SAFER-CODE*"
   "CHANGE-MEMORY-MANAGEMENT"
   "ENABLED-FLOATING-POINT-TRAPS"
   "FOREIGN-VALUE"
   "FOREIGN-SIZE-OF"
   "INITIALIZE-CALLBACKS"
   "RESET-LTOA"
   "DEFTEST"
   )

  )

(defpackage "LCL-USER"
  (:use "COMMON-LISP" "CLTL1" "LCL")
  (:nicknames "LCLU" "LUSER")
  )

(defvar *ltoa-verbose-noop* nil)

(defun ltoa-warn (format &rest args)
  (when *ltoa-verbose-noop*
    (apply #'warn
           (concatenate 'string
             "LtoA: Ignoring this Lucid call or option.~%" format)
           args)))

(defvar *all-tests* nil)

(defmacro deftest (&rest forms)
  (if (atom forms)
      `(pprint *all-tests*)
    (if (eq (car forms) :all)
	`(dolist (x (reverse *all-tests*))
	   (with-simple-restart (:ignore "Ignore form")
	     (funcall (symbol-function (car x)))))
      `(progn
	 ,@(mapcan 
	    #'(lambda (form)
		(unless (or (atom form)
			    (eq 'quote (car form)))
		  (let* ((base (format nil "~A" form))
			 (l (length base))
			 (handle (if (< l 60)
				     base
				   (subseq base 0 60)))
			 (place (find handle *all-tests* :test #'equal
				      :key #'(lambda (x) 
					       (when (consp x) (second x)))
				      ))
			 (name (if place 
				   (car place) 
				 (gentemp "TEST" "LCL-USER")))
			 )
		    `(progn (pushnew (list ',name ,handle) *all-tests* 
				     :test #'equal)
			    (defun ,name ()
			      (progn
				(format t "~&~%Test:   ~S~%" ',name)
				(format t "~&Form:   ~S~%" ',form)
				(format t "~&Values: ~{~S~%        ~}~%"
					(multiple-value-list ,form)))
			      )))))
	    forms)))))


(defvar *user-defined-foreign-types*
    (make-hash-table :test 'eq))


;;;
;;; Miscellaneous Functions
;;;

(defvar *COMMON-LISP-PACKAGE*
    (find-package "COMMON-LISP"))

(defvar *LOAD-BINARY-PATHNAME-TYPES* (list excl:*fasl-default-type*))

(defvar *ENTER-TOP-LEVEL-HOOK* nil)



(defmacro defsubst (&body body)
  (cons 'defun body))

(defmacro def-compiler-macro (&rest rest)
   `(define-compiler-macro ,rest))

(defmacro define-compiler-subst (&rest rest)
   `(defun ,@rest))

(defun define-function (name func)
   (setf (symbol-function name) func)
   name)

(defun define-macro (name func)
   (setf (macro-function name) func)
   name)

(defun delete-defstruct (name)
  (ltoa-warn "LCL:DELETE-DEFSTRUCT ~S" name)
  name)

(excl:without-package-locks
 
 (defun ignore (&rest x)
   (declare (ignore x))
   nil)
 
 )

(defun %POINTER (x)
  (EXCL::POINTER-TO-address x))

(defun delq (item list)
   (delete item list :test #'eq))

(defun disable-stack-lists ()
  (ltoa-warn "LCL:DISABLE-STACK-LISTS")
  nil)

(defun enable-stack-lists ()
  (ltoa-warn "LCL:ENABLE-STACK-LISTS")
  nil)

(defun egc-off (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:EGC-OFF")
  nil)

(defun egc-on (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:EGC-ON")
  nil)

(defun egc-options (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:EGC-PTIONS")
  nil)

(defun egc-state (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:EGC-STATE")
  nil)

(defun ephemeral-gc (&rest x)
  (declare (ignore x))
  (excl:gc)
  nil)

(defun gc (&rest x)
  (declare (ignore x))
  (excl:gc t))

(defun gc-off (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:GC-OFF")
  nil)

(defun gc-on (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:GC-ON")
  nil)

(defun GC-SIZE (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:GC-SIZE")
  (values 0 0 0))

(defun CHANGE-MEMORY-MANAGEMENT (&rest args)
  (ltoa-warn "LCL:CHANGE-MEMORY-MANAGEMENT ~a~%" args))

(defun ENABLED-FLOATING-POINT-TRAPS ()
  (ltoa-warn "LCL:ENABLED-FLOATING-POINT-TRAPS"))



(defun LISP-IMAGE-NAME (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:LISP-IMAGE-NAME")
  nil)

(defun LOAD-PATCHES (&rest x)
  (declare (ignore x))
  (ltoa-warn "LCL:LOAD-PATCHES")
  nil)

(defun DECACHE-EVAL ()
  (ltoa-warn "LCL:DECACHE-EVAL")
  nil)

(defun COMPILE-ALL-DISPATCH-CODE ()
  (ltoa-warn "LCL:COMPILE-ALL-DISPATCH-CODE")
  nil)

(defun PRECOMPILE-GENERIC-FUNCTIONS ()
  (ltoa-warn "LCL:PRECOMPILE-GENERIC-FUNCTIONS")
  nil)

(defun list-reverse (l)
  ;; what about non-nil final cdr -- should ignore -- ok
  (reverse l))

(defun list-nreverse (l)
  ;; what about non-nil final cdr -- should ignore -- ok
  (nreverse l))

(defun quit (&rest x)
  (declare (ignore x))
  (excl:exit))

(defun rehash (x)
  (ltoa-warn "LCL:REHASH")
  x)

(defun sequencep (x)
  (or (listp x) (vectorp x)))

(defun SIMPLE-STRING-LENGTH (x)
  (length x))

(defmacro WITH-STATIC-AREA (&body body)
  `(excl:tenuring ,@body))


(defmacro WITH-NORMAL-CONSING-AREA (&body body)
  `(progn
     (ltoa-ignore "LCL:WITH-NORMAL-CONSING-AREA")
     ,@body))


;;; Fixnum arithmetic

(defmacro fast-fixnum-macro (fastop clop)
  `(defmacro ,fastop (x y)
     (list 'the 'fixnum
           (list ',clop (list 'the 'fixnum x) (list 'the 'fixnum y)))))

(fast-fixnum-macro *& *)
(fast-fixnum-macro +& +)
(fast-fixnum-macro -& -)
(fast-fixnum-macro /=& /=)
(fast-fixnum-macro <& <)
(fast-fixnum-macro <=& <=)
(fast-fixnum-macro =& =)
(fast-fixnum-macro >& >)
(fast-fixnum-macro >=& >=)
(fast-fixnum-macro abs& abs)
(fast-fixnum-macro ash& ash)
(fast-fixnum-macro boole& boole)
(fast-fixnum-macro CEILING& CEILING)
(fast-fixnum-macro DEPOSIT-BYTE& DEPOSIT-BYTE)
(fast-fixnum-macro DEPOSIT-FIELD& DEPOSIT-FIELD)
(fast-fixnum-macro DPB& DPB)
(fast-fixnum-macro EQL& EQL)
(fast-fixnum-macro EVENP& EVENP)
(fast-fixnum-macro FLOOR& FLOOR)
(fast-fixnum-macro GCD& GCD)
(fast-fixnum-macro INTEGER-LENGTH& INTEGER-LENGTH)
(fast-fixnum-macro LDB& LDB)
(fast-fixnum-macro LOGAND& LOGAND)
(fast-fixnum-macro LOGANDC1& LOGANDC1)
(fast-fixnum-macro LOGANDC2& LOGANDC2)
(fast-fixnum-macro LOGBITP& LOGBITP)
(fast-fixnum-macro LOGCOUNT& LOGCOUNT)
(fast-fixnum-macro LOGIOR& LOGIOR)
(fast-fixnum-macro LOGNAND& LOGNAND)
(fast-fixnum-macro LOGNOR& LOGNOR)
(fast-fixnum-macro LOGNOT& LOGNOT)
(fast-fixnum-macro LOGORC1& LOGORC1)
(fast-fixnum-macro LOGORC2& LOGORC2)
(fast-fixnum-macro LOGTEST& LOGTEST)
(fast-fixnum-macro LOGXOR& LOGXOR)
(fast-fixnum-macro MASK-FIELD& MASK-FIELD)
(fast-fixnum-macro MAX& MAX)
(fast-fixnum-macro MIN& MIN)
(fast-fixnum-macro MOD& MOD)
(fast-fixnum-macro REM& REM)
(fast-fixnum-macro ROUND& ROUND)
(fast-fixnum-macro TRUNCATE& TRUNCATE)


(defmacro fast-fixnum-single (fastop clop)
  `(defmacro ,fastop (x)
     (list 'the 'fixnum
           (list ',clop (list 'the 'fixnum x)))))

(fast-fixnum-single 1+& 1+)
(fast-fixnum-single 1-& 1-)
(fast-fixnum-single MINUSP& MINUSP)
(fast-fixnum-single ODDP& ODDP)
(fast-fixnum-single PLUSP& PLUSP)
(fast-fixnum-single ZEROP& ZEROP)


(defmacro fast-fixnum-opt (fastop clop)
  `(defmacro ,fastop (x &optional y)
     (list 'the 'fixnum
           (list* ',clop (list 'the 'fixnum x)
                  (when y
                    (list
                     (list 'the 'fixnum y)))))))

(fast-fixnum-opt DECF& DECF)
(fast-fixnum-opt INCF& INCF)



(defun BYTE-SPECIFIER-P (x)
  (and (consp x) (fixnump (car x)) (fixnump (cdr x))))

(deftype BYTE-SPECIFIER ()
  '(satisfies BYTE-SPECIFIER-P))

(deftype C-STRING-TYPE () 'simple-string)

(defun CLOSE-ALL-FILES ()
  (ltoa-warn "LCL:CLOSE-ALL-FILES")
  nil)

(defun COMMAND-LINE-ARGUMENT (index)
  (system:COMMAND-LINE-ARGUMENT index :application nil))

(defun deposit-byte (int pos size newbyte)
  (dpb newbyte (byte size pos) int))

(defun load-byte (int pos size)
  (ldb (byte size pos) int))

(defmacro do-present-symbols ((var &optional (package '*package*) result)
                              &body body)
  (let ((pvar (gensym)) (gvar (gensym)))
    `(let ((,pvar ,package))
       (unless (packagep ,pvar)
	 (setq ,pvar (find-package ,pvar)))
       (do-symbols (,gvar ,package ,result)
	 (when (eq ,pvar (home-package ,gvar)
		   (funcall #'(lambda (,var) ,@body) ,pvar)))
	 )
       )
    ))


(defmacro FAST-READ-BYTE (&rest rest)
  `(READ-BYTE ,@rest))

(defmacro FAST-READ-CHAR (&rest rest)
  `(READ-CHAR ,@rest))

(defmacro FAST-UNREAD-CHAR (&rest rest)
  `(UNREAD-CHAR ,@rest))

(defmacro FAST-WRITE-BYTE (&rest rest)
  `(WRITE-BYTE ,@rest))

(defmacro FAST-WRITE-CHAR (&rest rest)
  `(WRITE-CHAR ,@rest))

(defmacro FAST-WRITE-STRING (&rest rest)
  `(WRITE-STRING ,@rest))

(defun pathname-lessp (x y)
  (string-lessp (namestring x) (namestring y)))

(defun read-array (stream vector &optional (start 0) (end (length vector))
						  eof-err-p eof-val)
  (declare (ignore eof-err-p eof-val))
  (read-sequence vector stream :start start :end end)
  )

(defun write-array (stream vector &optional (start 0) (end (length vector)))
  (write-sequence vector stream :start start :end end)
  vector)

(defun REPORT-COMPILER-OPTIONS ()
  (warn "Use of EXCL:EXPLAIN-COMPILER-SETTINGS is preferred.")
  (excl:explain-compiler-settings)
  )

(defun RESET-COMPILER-OPTIONS ()
  (ltoa-warn "LCL:RESET-COMPILER-OPTIONS")
  )

(defun SIMPLE-ARRAY-P (x)
  (typep x 'simple-array))

(defun SIMPLE-BASE-STRING-P (x)
  (typep x 'SIMPLE-BASE-STRING))

(defun STRING-OUTPUT-STREAM-P (x)
  (and (output-stream-p x)
       (typep x 'string-stream)))

(defun xor (&rest args)
  (if (null args) 
      nil
    (if (car args)
	(not (xor (cdr args)))
      (xor (cdr args))))
  )

(defmacro WITH-DEFERRED-WARNINGS (&body body)
  `(progn
     (ltoa-warn "LCL:WITH-DEFERRED-WARNINGS")
     ,@body))


(defmacro WITH-COMPILER-OPTIONS (options &body body)
  `(progn
     (ltoa-warn "LCL:WITH-COMPILER-OPTIONS ~S" ,options)
     ,@body))

(defmacro WITH-BUFFERED-TERMINAL-OUTPUT (stream &body body)
  `(progn
     (ltoa-warn "LCL:WITH-BUFFERED-TERMINAL-OUTPUT ~S" ,stream)
     ,@body))


;;; 
;;; Multiprocessing Functions
;;;

(defun CHECK-STACK-REMAINING (w)
  (declare (ignore w))
  (ltoa-warn "LCL:CHECK-STACK-REMAINING")
  nil)

(defun ACTIVATE-PROCESS (p)
  (mp:process-enable p))

(defun DEACTIVATE-PROCESS (p)
  (mp:process-disable p))

(defun GET-STACK-REMAINING (&optional sg)
  (declare (ignore sg))
  (cerror "Return the value 16384."
          "LtoA: GET-STACK-REMAINING cannot be called in Allegro CL.")
  16384)

(defun processp (x)
  (typep x 'process))

(defvar *pending-interruptions* :global)

(defun INTERRUPT-PROCESS (process function &rest args)
  (apply #'mp:process-interrupt
         process
         #'(lambda (function &rest args)
             (block done
               (excl:without-interrupts
                 (when (listp *pending-interruptions*)
                   (setq *pending-interruptions*
                     (nconc *pending-interruptions*
                             (list (cons function args))))
                   (return-from done)))
               (let ((*pending-interruptions* (list (cons function args))))
                 (flush-pending-interruptions nil))))
         function args)
  process)

(defun KILL-PROCESS (process &key suppress-unwind-protects)
  (if suppress-unwind-protects
      (mp:process-reset process t t)
    (mp:process-kill process))
  process)

(defmacro LET-GLOBALLY (vars &body body)
  (let  ((names (mapcar #'(lambda (x) (if (consp x) (car x) x)) vars))
         (vals  (mapcar #'(lambda (x) (if (consp x) (second x) nil)) vars))
         (gen1  (mapcar #'(lambda (x) (declare (ignore x)) (gensym)) vars))
         (gen2  (mapcar #'(lambda (x) (declare (ignore x)) (gensym)) vars)))
    `(let (,@gen1 ,@gen2)
       ;; collect all the values of initializing expressions
       ,@(mapcar #'(lambda (x y) `(setq ,x ,y)) gen1 vals)
       (unwind-protect
           (progn
             (excl:without-interrupts
               ;; save the current glbal values
               ,@(mapcar #'(lambda (x y) `(setq ,x ,y)) gen2 names)
               ;; store the new values
               ,@(mapcar #'(lambda (x y) `(setq ,x ,y)) names gen1)
               )
             ;; do the work
             (let () ,@body))
         (excl:without-interrupts
           ;; restore the old global values
           ,@(mapcar #'(lambda (x y) `(setq ,x ,y)) names gen2)
           )))
    ))

(defun MAKE-PROCESS (&key name function args stack-size
                          priority wait-function wait-args
                          restart-action
                          )
  (let (process)

    (unless (or (functionp function)
		(and (symbolp function) (fboundp function)
		     (setq function (symbol-function function))))
      (error
       "LCL:MAKE-PROCESS: The FUNCTION argument, ~A,~%must be supplied, and must be a function or the name of a function."
       function))
    (when stack-size
      (ltoa-warn "MAKE-PROCESS called with STACK-SIZE argument."))
    (when restart-action
      (ltoa-warn "MAKE-PROCESS called with RESTART-ACTION argument."))
    (when (and priority (> priority 100))
      (setq priority 100)
      (ltoa-warn "MAKE-PROCESS called with PRIORITY argument > 100."))
    (when wait-function
      (setq function #'(lambda () (when (apply wait-function wait-args)
                                    (apply function args)))))
    (setq process (mp:make-process
                   :name name
                   :priority (- 100 (or priority 100))
                   ))
    (apply #'mp:process-preset process function args)
    (mp:process-enable process)
    process))

(defun PROCESS-ACTIVE-P (p)
  (mp:process-active-p p))

(defun PROCESS-ALIVE-P (p)
  (or
   (mp:process-active-p p)
   (and
    (null (mp:process-run-reasons p))
    (null (mp:process-arrest-reasons p)))
   ))

(defmacro PROCESS-LOCK (place &optional (value '*current-process*)
                                        (action :wait)
                                        (whostate "locked place"))
  (let ((old (gensym))
        (lv (gensym))
        (act (gensym))
        (bn (gensym))
        (who (gensym))
        )
    `(let ((,old ,place)
           (,lv ,value)
           (,act ,action)
           (,who ,whostate))
       (block ,bn
         (case
             (excl:without-interrupts
               (if (null ,old)
                   (progn
                     (setf ,place ,lv)
                     (return-from ,bn nil))
                 (if (eq ,old ,lv)
                     (return-from ,bn t)
                   (case ,act
                     (:wait :wait)
                     (:abort (return-from ,bn nil))
                     (:abort-on-deadlock
                      (when sys:*disallow-scheduling*
                        (return-from ,bn nil))
                      :wait)
                     (otherwise
                      (if (numberp ,act)
                          :time
                        :bad-action))
                     ))))
           (:wait (mp:process-wait ,who #'(lambda ()
                                            (when (null ,place)
                                              (setf ,place ,lv)
                                              t)))
                  t)
           (:time (mp:process-wait-with-timeout
                   ,who ,act
                   #'(lambda ()
                       (when (null ,place)
                         (setf ,place ,lv)
                         t)))
                  t)
           (:bad-action
            (error "LCL:PROCESS-LOCK: Invalid action argument ~A." ,act))
           )))))

(defmacro process-unlock (place &optional (value '*current-process*)
                                          (action :cerror))
  (let ((old (gensym)) (lv (gensym)) (act (gensym)))
    `(excl:without-interrupts
       (let ((,old ,place)
             (,lv ,value)
             (,act ,action))
         (if (eq ,old ,lv)
             (progn (setf ,place nil)
                    nil)
           (case ,act
             (:ignore
              (if (null ,lv)
                  :lock-not-locked
                :locked-by-different-process))
             (otherwise
              (cerror "Ignore this call."
                      "LCL:PROCESS-UNLOCK: Cannot unlock."))))))
    ))

(defmacro with-process-lock ((place &optional (value '*current-process*)
                              &key (flag (gensym))
                                   (action :wait)
                                   (wait-state "locked place"))
                             &body body)
  (let ((act (gensym)) (old (gensym)) (who (gensym)) (lv (gensym))
        (bn (gensym)))
    `(let ((,lv ,value)
           (,act ,action)
           (,who ,wait-state)
           (,old ,place)
           (,flag nil))
       (block ,bn
         (case
             (excl:without-interrupts
               (if (null ,old)
                   (progn
                     (setf ,place ,lv)
                     (setq ,flag t)
                     :ok)
                 (if (eq ,old ,lv)
                     :ok
                   (case ,act
                     (:wait :wait)
                     (:abort (return-from ,bn nil))
                     (:abort-on-deadlock
                      (when sys:*disallow-scheduling*
                        (return-from ,bn nil))
                      :wait)
                     (otherwise
                      (if (numberp ,act)
                          :time
                        :bad-action))
                     ))))
           (:ok t)
           (:wait (mp:process-wait ,who #'(lambda ()
                                            (when (null ,place)
                                              (setf ,place ,lv)
                                              t))))
           (:time (mp:process-wait-with-timeout
                   ,who ,act
                   #'(lambda ()
                       (when (null ,place)
                         (setf ,place ,lv)
                         (setq ,old ,lv)
                         t)))
                  (if (eq ,old ,lv)
                      t
                    (return-from ,bn nil)))
           (:bad-action
            (error
             "LCL:WITH-PROCESS-LOCK: Invalid action argument ~A." ,act)))

         ;; Once we get here, we have the lock.
         (unwind-protect

             (progn ,@body)

           ;; Since we own the lock, we can reset without blocking
           ;; interrupts.
           (setf ,place ,old)

           )))
  ))


(defun PROCESS-STATE (p)
  (if (mp:process-active-p p)
      :active
    (if (and
         (null (mp:process-run-reasons p))
         (null (mp:process-arrest-reasons p)))
        :inactive
      :killed))
  )

(defsetf process-state (p) (v)
  `(process-state-set ,p ,v))

(defun PROCESS-STATE-set (p v)
  (if (mp:process-active-p p)
      (case v
	(:active p)
	(:inactive (mp:process-disable p))
	(:killed (mp:process-kill p))
	(t (error ":LtoA: Invalid process state for setf - ~S" v)))
    (if (and
         (null (mp:process-run-reasons p))
         (null (mp:process-arrest-reasons p)))
	(case v
	  (:active (mp:process-enable p))
	  (:inactive p)
	  (:killed (mp:process-kill p))
	  (t (error ":LtoA: Invalid process state for setf - ~S" v)))
      (case v
	(:killed p)
	(t (error ":LtoA: Invalid process state for setf - ~S" v)))
      ))
  )

(defun PROCESS-INITIAL-FUNCTION (p)
  (car (mp:process-initial-form p))
  )

(defsetf PROCESS-INITIAL-FUNCTION (p) (v)
  `(PROCESS-INITIAL-FUNCTION-set ,p ,v))

(defun PROCESS-INITIAL-FUNCTION-set (p v)
  (let ((x (mp:process-initial-form p)))
    (when (consp x) (setf (car x) v))
    v))

(defun PROCESS-INITIAL-ARGUMENTS (p)
  (cdr (mp:process-initial-form p))
  )

(defsetf PROCESS-INITIAL-ARGUMENTS (p) (v)
  `(PROCESS-INITIAL-ARGUMENTS-set ,p ,v))

(defun PROCESS-INITIAL-ARGUMENTS-set (p v)
  (let ((x (mp:process-initial-form p)))
    (when (consp x) (setf (cdr x) v))
    v))

(defun process-has-stack-p (p)
  (case (mp:stack-group-state (mp:process-stack-group p))
    ((:active :resumable) t)
    (otherwise nil)))

(defun PROCESS-INTERRUPTIONS (p)
  (when (process-has-stack-p p)
    (multiple-value-bind (val status)
	(mp:symeval-in-stack-group '*pending-interruptions*
				   (mp:process-stack-group p))
      (when status
        (if (listp val)
            val
          nil)))
    ))

(defmacro PROCESS-PLIST (p)
  `(mp:process-property-list ,p))

(defmacro PROCESS-WAIT-ARGUMENTS (p)
  `(mp:process-wait-args ,p))

(defun PROCESS-WAIT (whostate function &rest args)
  (let (v)
    (apply #'mp:process-wait 
	   whostate
	   #'(lambda (&rest args)
	       (setq v (apply function args)))
	   args)
    v))

(defun PROCESS-WAIT-WITH-TIMEOUT (whostate seconds function &rest args)
  (let (v)
    (if (apply #'mp:process-wait-with-timeout
	       whostate
	       seconds
	       #'(lambda (&rest args)
		   (setq v (apply function args)))
	       args)
        v
      nil)))

(defun PROCESS-WAIT-FOREVER (&optional (whostate "Wait Forever"))
  (mp:process-wait whostate #'(lambda () nil)))

(defun RESTART-PROCESS (p)
  (mp:process-reset p))

(defun SHOW-PROCESSES ()
  (terpri)
  (dolist (p *all-processes*)
    (format t "~A ~A~%"
            (if (eq p *current-process*) "*" " ")
            p))
  (terpri)
  (values))

(defun SYMBOL-GLOBAL-VALUE (symbol)
  (multiple-value-bind (val flag)
      (global-symbol-value symbol)
    (if (eq flag :unbound)
        (error "LCL:SYMBOL-GLOBAL-VALUE: Unbound symbol ~S." symbol)
      val)))

(defun (SETF SYMBOL-GLOBAL-VALUE) (value symbol)
  (setf (global-symbol-value symbol) value))


(defun SYMBOL-GLOBAL-BOUNDP (symbol)
  ;; This will give the wrong answer sometimes because of bug3382 ???
  (multiple-value-bind (val flag)
      (global-symbol-value symbol)
    (declare (ignore val))
    (if (eq flag :unbound)
        nil
      t)))

(defun symbol-dynamic-binding (symbol &optional
				      (process *current-process*))
  (when (process-has-stack-p process)
    (multiple-value-bind (val flag)
	(mp:symeval-in-stack-group symbol (mp:process-stack-group process))
      (declare (ignore val))
      (if (null flag)
	  nil
	;; t or :unbound
	flag))))

(defun SYMBOL-DYNAMICALLY-BOUNDP (symbol &optional
					 (process *current-process*) ;; <18>
					 )
  (when (symbol-dynamic-binding symbol process) t))

(defun SYMBOL-PROCESS-BOUNDP (symbol process &aux x)
  (if (setq x (symbol-dynamic-binding symbol process))
      (not (eq x :unbound))
    (symbol-global-boundp symbol)
    ))


(defun SYMBOL-PROCESS-VALUE (symbol process)
  (if (process-has-stack-p process)
      (multiple-value-bind (val flag)
	  (mp:symeval-in-stack-group symbol (mp:process-stack-group process))
	(if (eq flag :unbound)
	    (error "LCL:SYMBOL-PROCESS-VALUE: Dynamically unbound symbol ~S."
		   symbol)
	  (if flag
	      val
	    (multiple-value-bind (val flag)
		(global-symbol-value symbol)
	      (if (eq flag :unbound)
		  (error
		   "LCL:SYMBOL-PROCESS-VALUE: Globally unbound symbol ~S."
		   symbol)
		val)))))
    (progn 
      (cerror "Use nil." "LCL:SYMBOL-PROCESS-VALUE: Process has no stack.")
      nil)
    ))

(defsetf symbol-process-value (sym p) (val)
  `(symbol-process-value-set ,sym ,p ,val))

(defun SYMBOL-PROCESS-VALUE-set (symbol process newval
				 &aux (sg (mp:process-stack-group process)))
  (if (process-has-stack-p process)
      (multiple-value-bind (val flag)
	  (mp:symeval-in-stack-group symbol sg)
	(declare (ignore val))
	(if (eq flag :unbound)
	    (set symbol newval)
	  (if flag
	      (setf (mp:symeval-in-stack-group symbol sg) newval)
	    (set symbol newval))))
    (cerror "Ignore." "(setf LCL:SYMBOL-PROCESS-VALUE): Process has no stack.")
    ))

(defmacro USING-INITIAL-IO (&body body)
  `(let ((*terminal-io* excl:*initial-terminal-io*))
     ,@body))

(defun flush-pending-interruptions (outer)
  (loop
    (let (item)
      (excl:without-interrupts
        (when (atom *pending-interruptions*)
          (setq *pending-interruptions* outer)
          (return))
        (setq item (pop *pending-interruptions*)))
      (apply (car item) (cdr item))))
  )

(defmacro WITH-INTERRUPTIONS-ALLOWED (&body body)
  `(let ((*pending-interruptions* *pending-interruptions*))
     (flush-pending-interruptions :allowed)
     ,@body))

(defmacro WITH-INTERRUPTIONS-INHIBITED (&body body)
  `(let ((outer *pending-interruptions*)
         inner)
     (unwind-protect
         (multiple-value-prog1
             (let ((*pending-interruptions* (if (listp outer) outer nil)))
               ,@body)
           (setq inner *pending-interruptions*))
       (block name
         (excl:without-interrupts
           (when (listp outer)
             ;; Interruptions were already inhibitted in
             ;; outer context.
             (unless (eq outer inner)
               ;; If not eq, outer value was NIL and not
               ;; updatable, so we need to store the accumulated
               ;; pending interruptions in the outer binding.
               (setq *pending-interruptions* inner))
             ;; Return to caller without handling any interruptions.
             (return-from name nil)))
         ;; If we get here, interruptions are allowed, so flush the list.
         (flush-pending-interruptions outer)))))


(defmacro WITH-SCHEDULING-ALLOWED (&body body)
  `(progn
     ,@(mapcan #'(lambda (x)
                   (list '(process-allow-schedule)
                         x))
               body))
  )

(defmacro with-scheduling-inhibited (&body body)
  `(mp:without-scheduling ,@body)
  )


(defmacro WITH-INTERRUPTS-DEFERRED (&body body)
  `(excl:without-interrupts ,@body))



;;; 
;;; Foreign Function Interface.
;;;


(defvar *LUCID-CALLBACK-FIXUPS* t
  "When T, causes C and Lisp fixup files to be written while compiling
Lisp functions to be called from C."
  )


(defvar *DEFAULT-FOREIGN-LIBRARIES* '("-lc" "-lm"))

(defvar *prototyped-c-fundecls* nil)

(defvar *foreign-callback-handles* nil)
(defvar *foreign-callback-init-suffix* "_init_handle")
(defvar *foreign-callback-call-suffix* "_call_handle")

(defvar *INITIALIZE-FOREIGN-STRUCTS* nil)

(defun INITIALIZE-CALLBACKS (&rest files)
  (let ((seen nil))
    (dolist (x files) (load x))
    (dolist (x *foreign-callback-handles*)
      (unless (member (third x) seen :test #'string=)
        (push (third x) seen)
        (load (third x))))
    (dolist (x *foreign-callback-handles*)
      (let ((init (first x))
            (entry (second x)))
        (funcall (symbol-function init)
                 (ff:register-function entry))))
    (setq *foreign-callback-handles* nil)
    ))

(defun convert-to-language (sym lang)
  (let ((string (string sym)))
    (case lang
      (:c
       (when (symbolp sym)
         (setq string (string-downcase string))
         (dotimes (i (length string))
           (when (char= (elt string i) #\-)
             (setf (elt string i) #\_)))))
      )
    string))

(defvar *LISP-SYMBOL-TO-FOREIGN-STRING-METHOD* ())

(defun derive-file-name (full-name suffix type)
  (when full-name
    (if (stringp full-name)
        (setq suffix "")
      (setq full-name nil))
    (let* ((source (or full-name *load-pathname* *compile-file-pathname*))
           (name (or full-name (when source (pathname-name source)))))
      (when source
        (make-pathname :name (concatenate 'string (or name "ltoa") suffix)
                       :type type
                       :defaults source)))))

(defvar *callback-file-action* :append)

(excl:advise compile-file :around ltoa nil
             (let ((*callback-file-action* :append))
               (when (and *LUCID-CALLBACK-FIXUPS*
                          (not (stringp *LUCID-CALLBACK-FIXUPS*)))
                 (setq *callback-file-action* :supersede))
               :do-it
               ))

(defun atype-to-ctype (x)
  (case x
    ((:signed-long :integer integer :fixnum fixnum)
     "long")
    ((:unsigned-long) "unsigned long")
    ((:single-float single-float) "float")
    ((:double-float double-float) "double")
    ((:character character) "char")
    ((:lisp lisp t) "long")
    (:void "void")
    (otherwise
     (error "LtoA Run-Time bug: Unknown Allegro CL foreign type ~S" x))))

(defmacro DEF-FOREIGN-CALLABLE (&rest args)
  (let (name options c-name (language :c) ret-type
        body lisp-vars c-args o-file
        )
    ;; parse arguments
    (cond ((atom args)
           (warn "LtoA: Ignoring ill-formed DEF-FOREIGN-CALLABLE form.")
           (return-from DEF-FOREIGN-CALLABLE nil))
          ((atom (car args)) (setq name (pop args)))
          (t (setq name (caar args)
                   options (cdar args)
                   args (cdr args))))
    (cond ((atom args)
           (warn "LtoA: Ignoring ill-formed DEF-FOREIGN-CALLABLE form.")
           (return-from DEF-FOREIGN-CALLABLE nil))
          (t (setq body (cdr args)
                   args (car args))))
    (setq c-name name)
    (dolist (opt options)
      (case (car opt)
        (:language    (setq language (second opt))
                      (unless (eq language :c)
                        (warn
                         "LtoA: Option ~S is not supported for callbacks."
                         opt)
                        (return-from DEF-FOREIGN-CALLABLE nil))
                      )
        (:return-type (setq ret-type
                        (convert-callback-return-type (second opt))))
        (:name        (setq c-name (second opt)))
        (otherwise
         (warn
          "LtoA: Ignoring illegal option: ~S" opt))))
    (dolist (arg args)
      (when (atom arg)
        (warn "LtoA: Ignoring ill-formed DEF-FOREIGN-CALLABLE form.")
        (return-from DEF-FOREIGN-CALLABLE nil))
      (multiple-value-bind (atype xform)
          (convert-callback-type (second arg))
        (let ((g (gensym)))
          (push (list g atype) c-args)
          (push (list (car arg) (if xform
                                    (list xform g)
                                  g))
                lisp-vars))))
    (if (symbolp c-name)
        (setq c-name (convert-to-language name language))
      (warn "LtoA: Explicit foreign name ~S will map to ~S"
            c-name (ff:convert-to-lang c-name :language language)))
    (setq c-args (reverse c-args))
    (setq lisp-vars (reverse lisp-vars))

    (when (derive-file-name *LUCID-CALLBACK-FIXUPS* "x" "y")
      (with-open-file (c-init (derive-file-name
                               *LUCID-CALLBACK-FIXUPS* "-callback" "c")
                       :direction :output :if-exists *callback-file-action*
                       :if-does-not-exist :create)
        (with-open-file (l-init (derive-file-name
                                 *LUCID-CALLBACK-FIXUPS*  "-callback" "cl")
                         :direction :output :if-exists *callback-file-action*
                         :if-does-not-exist :create)
          ;; after the first time, always append
          (setq *callback-file-action* :append)
          (setq o-file (namestring (derive-file-name
                        *LUCID-CALLBACK-FIXUPS* "-callback" "o")))

          ;; Update C init file

          (let ((c-ret-type (atype-to-ctype ret-type))
                (result-inc (case ret-type
                              ((fixnum integer character single-float
                                double-float)
                               8)
                              ((array string) 4)
                              (otherwise nil))))

            (if *prototyped-c-fundecls*
                (format c-init "~%long (*~A~A)(~@[~A~]~{, ~A~});~%~%"
                        c-name *foreign-callback-call-suffix*
                        (when c-args (atype-to-ctype (cadar c-args)))
                        (mapcar #'(lambda (x) (atype-to-ctype (cadr x)))
                                (cdr c-args)))
              (format c-init "~%long (*~A~A)();~%~%"
                      c-name *foreign-callback-call-suffix*))
            (format c-init "void ~A~A(x)~%"
                    c-name *foreign-callback-init-suffix*)
            (format c-init "  long x;             ~%")
            (format c-init "  {                   ~%")
            (format c-init "  (long)~A~A=x;   ~%"
                    c-name *foreign-callback-call-suffix*)
            (format c-init "  }                   ~%~%")

            (format c-init "extern ~A ~A(~@[~A~]~{, ~A~}) ~%"
                    c-ret-type
                    c-name
                    (when c-args (caar c-args))
                    (mapcar #'car (cdr c-args)))
            (format c-init "~{   ~A ~A;~%~}"
                    (mapcan #'(lambda (x)
                                (list (atype-to-ctype (second x)) (car x)))
                            c-args))
            (format c-init "  {                   ~%")
            (format c-init "  long result;        ~%")
            (format c-init "  result=(*~A~A)(~@[~A~]~{, ~A~});~%"
                    c-name *foreign-callback-call-suffix*
                    (when c-args (caar c-args))
                    (mapcar #'car (cdr c-args)))
            (when result-inc
              (format c-init "  result=(result&0xfffffff8)+~A;~%" result-inc))
            (format c-init "  return *((~A*)result);   ~%" c-ret-type)
            (format c-init "  }                   ~%")
            )

          ;; Update Lisp init file

          ;; Insert a new IN-PACKAGE for each form, because we may be
          ;; collecting pieces from many different files
          (format l-init "~%(in-package ~S)~%" (package-name *package*))
          (format l-init "~%(ff:defforeign '~A-init-handle      ~%" name)
          (format
           l-init
           "     :entry-point (ff:convert-to-lang ~S :language :c)   ~%"
           (concatenate 'string c-name *foreign-callback-init-suffix*))
          (format l-init "     :arguments '(integer))      ~%~%")
          (format l-init "(push (list '~S-init-handle '~S ~S)~%"
                  name name o-file)
          (format l-init "    lcl:*foreign-callback-handles*)~%")
          )))

    ;; Emit run-time code

    `(progn
       (ff:register-function ',name)
       (ff:defun-c-callable
           ,name
           ,c-args
         (store-callback-value-in-place
          (let ,lisp-vars ,@body)
          ',ret-type)
         )
       ',name)))

(ff:def-c-type callback-char-place :char)
(ff:def-c-type callback-long-place :long)
(ff:def-c-type callback-single-place :single-float)
(ff:def-c-type callback-double-place :double-float)
(defvar *callback-place* (make-callback-double-place))
(deftype lisp () t)

(defun store-callback-value-in-place (value ctype)
  (setq value (coerce value ctype))
  (case ctype
    (character (setf (callback-char-place *callback-place*)
                 (char-int value))
               *callback-place*)
    ((fixnum integer)  (setf (callback-long-place *callback-place*) value)
                       *callback-place*)
    (single-float (setf (callback-single-place *callback-place*) value)
                       *callback-place*)
    (double-float (setf (callback-double-place *callback-place*) value)
                  *callback-place*)
    ((array string lisp) value)
    (t (if value 1 0))
    ))

(defun convert-callback-return-type (type)
  ;; Convert type of Lisp value returned to C
  (case type
    (:character       'character)
    (:signed-32bit    'integer)
    (:unsigned-32bit  'integer)
    (:single-float    'single-float)
    (:double-float    'double-float)
    (:fixnum          'fixnum)
    (:pointer         'integer)
    (:array           'array)
    (:simple-vector-type 'array)
    (:simple-string   'string)
    (:string          'string)
    (:boolean         't)
    (:lisp            'lisp)
    (otherwise
     (if (atom type)
	 (if (null type)
	     'integer
	   (error "LtoA Run-Time: Unknown Lucid return-to-C type -> ~S" type))
       (case (car type)
         (:pointer    'integer)
         (otherwise
          (error "LtoA Run-Time: Unknown Lucid return-to-C t type -> ~S"
                 type)))))))

;; This is a macro to reduce some of the run-time overhead 
;;      if arg happens to be ok
(defmacro force-double-float (x)
  (if (numberp x)
    (coerce x 'double-float)
    `(let ((x ,x))
      (if (typep x 'double-float)
	x
	(coerce x 'double-float)))))

(defun convert-foreign-type (type)
  ;; Convert type of Lisp argument passed to C
  ;;  or Lisp value returned to C
  (case type
    (:arbitrary t)
    (:character       'character)
    (:signed-64bit    'integer)
    (:signed-32bit    'integer)
    (:unsigned-64bit  'fixnum)
    (:unsigned-32bit  'integer)
    (:single-float    'single-float)
    ;; We need to force to double-float because in LCL extracting from 
    ;;  single-float array automatically made a double, 
    ;;  but in ACL we get a single-float, so single-floats may
    ;;  appear in places where only doubles are expected.
    (:double-float    (values 'double-float 'force-double-float))
    (:fixnum          'fixnum)
    (:pointer         'integer)
    (:array           'array)
    (:simple-vector-type 'array)
    (:simple-string   'string)
    (:string          'string)
    (:boolean         't)
    (:lisp            (values 'integer
                              'excl::pointer-to-integer))
    (otherwise
     (if (atom type)
	 (if (gethash type *user-defined-foreign-types*)
	     'integer
	   (error "LtoA Run-Time: Unknown Lucid foreign type -> ~S" type))
       (case (car type)
         (:pointer    'integer)
	 ;; We assume the user is passing the contents of a Lisp array
	 ;; as the corresponding foreign array.
	 ;; (If an actual foreign pointer is passed, we get a runtime error)
	 (:array      'array)
         (otherwise
	  (if (gethash (car type) *user-defined-foreign-types*)
	      'integer
	    (error "LtoA Run-Time: Unknown Lucid foreign type -> ~S" 
		   type))))))))

(defun convert-return-type (type)
  ;; Convert type of C value returned to Lisp
  (case type
    (:arbitrary       :integer)
    (:character       :character)
    ;;(:signed-64bit    (error "??? :signed-64bit"))
    ((nil :signed-32bit)    :integer)
    ;;(:unsigned-64bit  (error "??? :unsigned-64bit"))
    (:unsigned-32bit  :integer)
    (:single-float    :single-float)
    (:double-float    :double-float)
    (:fixnum          :fixnum)
    (:pointer         :integer)
    (:array           :integer)
    (:simple-vector-type :integer)
    (:simple-string   (values :integer 'foreign-string-value-inner))
    (:boolean         :integer)
    (:lisp            :lisp)
    (:null            :void)
    (otherwise
     (if (atom type)
         (error "LtoA Run-Time: Unknown Lucid foreign return type -> ~S" type)
       (case (car type)
         (:pointer    :integer)
         (otherwise
          (error "LtoA Run-Time: Unknown Lucid foreign return type -> ~S"
                 type)))))))

(defun convert-callback-type (type)
  ;; Convert type of C argument passed to Lisp
  (case type
    (:arbitrary       :unsigned-long)
    (:character       (values :fixnum 'int-char))
    ;;(:signed-64bit    (error "??? :signed-64bit"))
    (:signed-32bit    :signed-long)
    ;;(:unsigned-64bit  (error "??? :unsigned-64bit"))
    (:unsigned-32bit  :unsigned-long)
    (:single-float    :single-float)
    (:double-float    :double-float)
    (:fixnum          :fixnum)
    (:pointer         :unsigned-long)
    (:array           :unsigned-long)
    (:simple-vector-type :unsigned-long)
    ((:string :simple-string)  (values :unsigned-long 
				       'foreign-string-value-inner))
    (:boolean         :unsigned-long)
    (:lisp            :lisp)
    (:null            :void)
    (otherwise
     (if (atom type)
         (error "LtoA Run-Time: Unknown Lucid foreign callback type -> ~S"
                type)
       (case (car type)
         (:pointer    :unsigned-long)
         (otherwise
          (error "LtoA Run-Time: Unknown Lucid foreign callback type -> ~S"
                 type)))))))

(defmacro def-foreign-subst (&rest args)
  `(def-foreign-function ,@args))

(defmacro DEF-FOREIGN-FUNCTION (&rest args)
  (let (name options lisp-args var vars argforms c-args
        ff-name c-name retform larg
        (language :c)
        (lret-type :integer) (aret-type :integer))
    (cond ((atom args)
           (warn "LtoA: Ignoring ill-formed DEF-FOREIGN-FUNCTION form.")
           (return-from DEF-FOREIGN-FUNCTION nil))
          ((atom (car args)) (setq name (pop args)))
          (t (setq name (caar args)
                   options (cdar args)
                   args (cdr args))))
    (dolist (arg args)
      (setq var nil)
      (cond
       ((member arg '(&optional &rest &key)) (setq larg arg))
       ((atom arg) (setq var arg) (setq larg arg) (push t c-args))
       (t (setq larg (car arg))
          (setq var (if (atom larg) larg (car larg)))
          (multiple-value-bind (atype xform)
              (convert-foreign-type (second arg))
            (push atype c-args)
            (push (if xform
                      (list xform var)
                    var)
                  argforms)))
       )
      (when var (push var vars))
      (push larg lisp-args))
    (setq c-name name)
    (dolist (opt options)
      (case (car opt)
        (:language (setq language (second opt)))
        (:name     (setq c-name (second opt)))
        (:return-type (multiple-value-setq (aret-type retform)
                        (convert-return-type (setq lret-type (second opt)))))
        (:max-rest-args nil)
        )
      )
    (if (symbolp c-name)
        (setq c-name (convert-to-language c-name language))
      (warn "LtoA: Explicit foreign name ~S will map to ~S"
            c-name (ff:convert-to-lang c-name :language language)))
    (if (and (equal lisp-args argforms)
             (equal argforms vars)
             (null retform))
        `(eval-when (compile load eval)
           (record-pointer-accessor ',name nil ',lret-type t)
           (ff:defforeign ',name
               :entry-point (ff:convert-to-lang ,c-name :language ,language)
               :arguments ',(reverse c-args)
               :return-type ',aret-type
               :language ',language
               :remember-address t
               )
           ',name)
      (progn
        (setq ff-name (make-symbol (symbol-name name)))
        `(eval-when (compile load eval)
           (record-pointer-accessor ',name nil ',lret-type t)
           (defun ,name ,(reverse lisp-args)
             (,(or retform 'identity)
              (,ff-name ,@(reverse argforms))))
           (ff:defforeign ',ff-name
               :entry-point (ff:convert-to-lang ,c-name :language ,language)
               :arguments ',(reverse c-args)
               :return-type ,aret-type
               :language ,language
               :remember-address t
               )
           ',name)))
    ))

;; This table allows us to transform
;; (foreign-aref (slot-acc foo) i j k)
;; into
;; (atype-accessor (slot-acc foo) i j k)
;;
;; slot-name -> (atypename slot-type)
;; frgn-func -> (nil value-type)
(defvar *known-pointer-accessors*
    (make-hash-table :test 'eq))


(defun reset-ltoa ()
  (setq *user-defined-foreign-types*
    (make-hash-table :test 'eq))
  (setq *known-pointer-accessors*
    (make-hash-table :test 'eq))
  nil)


(defun record-pointer-accessor (name sname type run-time)
  (let ((exp (expand-foreign-type type))
        an ts tn slot)
    (cond
     ((null exp) nil)
     ((and sname (atom exp))
      ;; slot is a sub-struct
      ;; When def-c-type is :in-foreign-space, slot accessor for
      ;; composite slot exists and returns pointer to sub-structure
      (setq slot 
	(intern (concatenate 'string (string name) "-" (string sname))))
      (setf (gethash slot *known-pointer-accessors*)
        (list nil exp))
      nil)
     ((and sname (consp exp) (equal :array (car exp)))
      ;; slot is an array
      ;; We need to interpose another struct layer so that immediate
      ;; slot name does not need subscript
      (setq slot 
	(intern (concatenate 'string (string name) "-" (string sname))))
      (if (setq tn (gethash slot *known-pointer-accessors*))
	  (setq an (first tn) ts (third tn) tn (fourth tn))
	(setq tn (gentemp) ts (gentemp)
	      an (intern (concatenate 'string (string tn) "-" (string ts)))
	      ))
      (setf (gethash slot *known-pointer-accessors*) (list an exp ts tn))
      (unless run-time
	(values tn
		`((define-foreign-synonym-type ',tn ',exp)
		  (ff:def-c-type (,tn :in-foreign-space)
		      :struct (,ts ,@(lstruct-to-astruct exp)))))))
     ((and sname (consp exp) (eq :pointer (car exp)))
      (setq slot
	(intern (concatenate 'string (string name) "-" (string sname))))
      (setf (gethash slot *known-pointer-accessors*)
        (list nil (second exp)))
      nil)
     ((and (null sname) (consp exp) (eq :pointer (car exp)))
      (setf (gethash name *known-pointer-accessors*)
        (list nil (second exp)))
      nil)
     )))

(defun find-name-of-type (exp)
  (let (found)
    (maphash #'(lambda (k v)
		 (when (equal v exp)
		   (setq found k)))
	     *user-defined-foreign-types*)
    found))

(defun record-pointer-type (type run-time)
  (if (and (consp type) (eq :pointer (car type))
	   (symbolp (second type)))
      nil
    (let ((exp (expand-foreign-type type))
	  tn)
      (when (and (not run-time) (consp exp) (eq :pointer (car exp)))
	(setq exp (second exp))
	(if (atom exp)
	    nil
	  (unless (find-name-of-type exp)
	    (values (setq tn (gentemp))
		    `((define-foreign-synonym-type ',tn ',exp)
		      (ff:def-c-type (,tn :in-foreign-space)
			,@(lstruct-to-astruct exp))))))
	))))

(defun decode-array-accessor (ptype)
  ;; convert an LCL pointer type into an ACL array accessor
  (let ((exp (expand-foreign-type ptype)))
      (when (and (consp exp) (eq :pointer (car exp)))
        (setq exp (second exp))
        (if (symbolp exp)
            ;; assume that this is an array type, and the name is the accessor
            exp
	  (let ((tn (find-name-of-type exp)))
	    (if (and (consp exp)
		     (eq :array (car exp))
		     (or (eq :char (second exp)) (eq :character (second exp))))
		(values tn 'int-char)
	      tn)))
        )))
  
  
(defun resolve-pointer-type (x make-p)
  ;; return the name of a foreign type or signal an error
  (if (and (consp x) (eq :pointer (car x))
           (symbolp (second x))
	   (gethash (second x) *user-defined-foreign-types*))
      (second x)
    (let ((exp (expand-foreign-type x))
	  found)
      (when (and (consp exp) (eq :pointer (car exp)))
	(setq exp (second exp))
	(if (and (symbolp exp)
		 (gethash exp *user-defined-foreign-types*))
	    exp
	  (progn
	    (setq found (find-name-of-type exp))
	    (if found
		found
	      (if make-p
		  (let ((tn (gentemp)))
		    (eval `(ff:def-c-type (,tn :in-foreign-space)
			       ,@(lstruct-to-astruct exp)))
		    (define-foreign-synonym-type tn exp)
		    tn)
		(error "LtoA: Need a pointer type instead of ~S" x))))))
      )))

(defun DEFINED-FOREIGN-TYPE-P (x)
  (if (expand-foreign-type x)
      t
    nil))

(defun UNDEFINE-FOREIGN-TYPE (x)
  (remhash x *user-defined-foreign-types*))

(defun expand-foreign-type (x &aux copy l)
  ;; if result is EQ to arg, then this is a primitive type
  (if (and (atom x)
	   (setq copy (gethash x *user-defined-foreign-types*))
	   (atom copy))
      (if (numberp copy)
	  (values x copy)
	(expand-foreign-type copy))
    (case (if (and (atom x) (consp copy))
	      (setq x copy)
	    x)
      ((:character :signed-8bit 
	:unsigned-8bit)
       (values x 1))
      ((:signed-16bit  :unsigned-16bit)
       (values x 2))
      ((:signed-32bit :unsigned-32bit
	:single-float)
       (values x 4))
      ((:double-float)
       (values x 8))
      (otherwise
       (if (atom x)
	   nil
	 (case (car x)
	   (:pointer   (setq copy (expand-foreign-type (second x)))
		       (values (if (and copy (atom copy))
				   x
				 (list :pointer copy))
			       4))
	   ((:field :signed-field)
	    (values x 4))
	   ((:field :signed-field :bit-field :signed-bit-field)
	    (values x (ceiling (+ (second x) (third x)) 8)))
	   (:array (multiple-value-setq 
		       (copy l) (expand-foreign-type (second x)))
		   (values
		    (if (and copy (atom copy))
		       x
		      (list* :array copy (cddr x)))
		    (apply #'* l (third x))
		    ))
	   ((:set :enumeration :packed-array)
	    (warn
	     "LtoA: This foreign type is not supported: ~S - Using ~S"
	     x :unsigned-32bit)
	    (values :unsigned-32bit 4))
	   (otherwise nil)))))))

(defun FOREIGN-TYPE-SIZE (type)
  (multiple-value-bind (exp size)
      (expand-foreign-type type)
    (declare (ignore exp))
    size))

(defun FOREIGN-SIZE-OF (pointer-or-type)
  (if (foreign-pointer-p pointer-or-type)
      (error "LtoA: FOREIGN-SIZE-OF defined only for foreign types.")
    (foreign-type-size pointer-or-type)))



(defun lstruct-to-astruct (x &aux exp)
  (case x
    ((:character :signed-8bit) (list :byte))
    ((:unsigned-8bit)  (list :unsigned-byte))
    ((:signed-16bit)   (list :short))
    ((:unsigned-16bit) (list :unsigned-short))
    ((:signed-32bit)   (list :long))
    ((:unsigned-32bit) (list :unsigned-long))
    ((:single-float :double-float) (list x))
    (otherwise
     (or
      (if (atom x)
          (progn
            ;; We need to expand the defined types to retain the
            ;; Lucid redefinition behavior.
            (setq exp (expand-foreign-type x))
            (if (and x exp (atom exp))
                ;; This is a user-defined struct type, therefore atomic
                (list x)
              (if (consp exp)
                  ;; This is a user defined synonym type, process the
                  ;; expansion in order to reproduce Lucid redef behavior.
                  (lstruct-to-astruct exp)
                nil)))
        (case (car x)
          (:pointer   (cons '* (lstruct-to-astruct (second x))))
          ((:field :signed-field :bit-field :signed-bit-field)
           ;; ??? what about trailing padding
           (unless (eql 0 (third x))
             (warn "LtoA: Forcing pos=0 in ~S" x))
           (list :bit (+ (second x) (third x))))
          (:array
           (when (eq :column-major (fourth x))
             (warn "LtoA: Ignoring :COLUMN-MAJOR option in ~S" x))
           `(,@(third x) ,@(lstruct-to-astruct (second x))))
          ((:set :enumeration :packed-array)
           (warn "LtoA: This foreign type is not supported: ~A - Using :LONG"
                 x)
           (list :long))
          (otherwise nil)))
      (progn
        (warn "LtoA: Ignoring bad foreign struct slot type: ~S" x)
        (list :long))
      ))
  ))

(defmacro DEF-FOREIGN-SYNONYM-TYPE (name old-type)
  (multiple-value-bind (tn tdefs)
      (record-pointer-type old-type nil)
    `(eval-when (compile load eval)
      ,@tdefs
      ;; We need to make this in foreign space so that "name" will
      ;; be an array accessor if needed
      (ff:def-c-type (,name :in-foreign-space :no-constructor)
	   ,@(if tn
		 (list '* tn)
		 (lstruct-to-astruct old-type)))
      (define-foreign-synonym-type ',name ',old-type))))

(defun define-foreign-synonym-type (name old-type &aux copy)
  (if (atom old-type)
      ;; this path is to register a defined foreign struct
      (setf (gethash name *user-defined-foreign-types*) old-type)
    (if (setq copy (expand-foreign-type old-type))
        (progn (record-pointer-type old-type t)
               (setf (gethash name *user-defined-foreign-types*)
                 copy))
      (warn "LtoA: Ignoring undefined foreign type: ~S = ~S" name old-type)))
  name)

(defmacro DEF-FOREIGN-STRUCT (&rest args)
  (let (name opts align mod rem slots overlays tdefs pdefs (size 0))
    (if (atom args)
        (progn (warn "LtoA: Ignoring ill-formed DEF-FOREIGN-STRUCT.")
               (return-from DEF-FOREIGN-STRUCT nil))
      (setq opts (pop args)))
    (if (atom opts)
        (setq name opts)
      (progn
        (setq name (pop opts))
        (unless (atom opts)
          (setq opts (car opts))
          (or
           (if (eq :alignment (car opts))
               (progn (setq align opts)
                      (setq opts (second opts))
                      (if (eq :modulus (first opts))
                          (setq mod (second opts)
                                rem (if (eq :remainder (third opts))
                                        (fourth opts))))))
           (progn (warn "LtoA: Ignoring ill-formed DEF-FOREIGN-STRUCT.")
                  (return-from DEF-FOREIGN-STRUCT nil))))))
    (when (or align mod rem)
      (warn "LtoA: Ignoring option ~S in foreign struct ~S." align name))
    (setq slots (list :struct))
    (dolist (slot args)
      (let ((sname (first slot))
            (stype (third slot))
            (ov/off (fourth slot))
            (val (fifth slot)) tnm sitem l)
        (flet ((record-intermediate-type ()
                 (multiple-value-bind (tn td)
                     (record-pointer-accessor name sname stype nil)
                   (setq tdefs (append tdefs td))
                   tn)))
          (when (eq ov/off :offset)
            (warn "LtoA: Ignoring :OFFSET in ~S" slot))
          (if (setq tnm (record-intermediate-type))
              (setq sitem `(,sname ,tnm))
            (setq sitem `(,sname ,@(lstruct-to-astruct stype))))
          (if (eq ov/off :overlays)
              (let ((found (assoc val overlays)))
                (unless found (push (setq found (list val)) overlays))
                (push sitem (cdr found)))
	    (progn
	      (multiple-value-setq (tnm l)
		(expand-foreign-type stype))
	      (incf size (or l 4))
	      (nconc slots (list sitem)))
            )
          )))
    (dolist (ov overlays)
      (do ((tl slots (cdr tl)))
          ((atom tl)
           (warn "LtoA: Ignoring undefined overlay ~S in ~S." ov name))
        (cond
         ((atom (car tl)))
         ((eq (car ov) (caar tl))
	  (let ((ts (gentemp)) (slot (car tl)))
	    (setf (car tl)
	      (list* ts :union slot (cdr ov)))
	    (setq pdefs
	      (nconc pdefs
		     (mapcan
		      #'(lambda (s)
			  (let ((ls (intern (concatenate 'string 
					     (string name) "-" (string (car s))))) 
				(as (intern (concatenate 'string
					 (string name) "-" (string ts) "-" 
					 (string (car s))))))
			    `((defun ,ls (x) (,as x))
			      (defsetf ,ls (x) (v) 
				(list 'setf (list ',as x) v)))
			    ))
		      (cons slot (cdr ov))))))
          (return))))

      )
    (if *INITIALIZE-FOREIGN-STRUCTS*
	`(eval-when (compile load eval)
	   ,@tdefs
	   (ff:def-c-type (,name :in-foreign-space :no-constructor) ,@slots)
	   (defun ,(intern (concatenate 'string "MAKE-" (string name))) ()
	     (malloc-foreign-pointer-init ',name))
	   ,@pdefs
	   (define-foreign-synonym-type ',name ,size))
    
      `(eval-when (compile load eval)
	 ,@tdefs
	 (ff:def-c-type (,name :in-foreign-space) ,@slots)
	 ,@pdefs
	 (define-foreign-synonym-type ',name ,size))
      )
  ))

(defun LOAD-FOREIGN-FILES (files &optional libraries symbols)
  #+SVR4
  (declare (ignore files symbols))
  #-SVR4
  (let ((ffiles (if (stringp files) (list files) files)) libs)
    (dolist (lib (or libraries *DEFAULT-FOREIGN-LIBRARIES*))
      (if (eql 0 (search "-l" lib))
          (push (subseq lib 2) libs)
        (setq ffiles (append ffiles (list lib)))))
    (setq libs (reverse libs))
    (load ""
          :foreign-files ffiles
          :system-libraries libs
          :unreferenced-lib-names symbols
          :update-entry-points t))
  #+SVR4
  (progn
    (let ((loaded-something nil))
      (mapcar #'(lambda (lib)
		  (when (string= "so" (pathname-type lib))
		    (when (probe-file lib)
		      (load lib))
		    (setq loaded-something t))) libraries)
      (when (unless loaded-something)
	(cerror "Ignore this call" "Nothing was loaded, check load form")))
    nil)
  )

(defun load-foreign-libraries (strings &optional libraries)
  (load-foreign-files nil libraries strings))

(defun FOREIGN-POINTER-ADDRESS (x)
  (if (integerp x)
      x
    (error "LtoA: Foreign pointer is not an integer.")))

(defun FOREIGN-POINTER-P (x)
  (integerp x))

(defmacro FOREIGN-POINTER-TYPE (x)
  `(foreign-pointer-type-fun ,x))

(defun foreign-pointer-type-fun (x)
  (declare (ignore x))
  (cerror "Continue using :UNSIGNED-32BIT"
	  "LtoA: The function FOREIGN-POINTER-TYPE is not supported.")
  :UNSIGNED-32BIT)

(defsetf foreign-pointer-type-fun (x) (val)
  `(foreign-pointer-type-set ,x ,val))

(defun foreign-pointer-type-set (x val)
  (declare (ignore x))
  (ltoa-warn "(SETF LCL:FOREIGN-POINTER-TYPE)")
  val)

(defmacro MAKE-FOREIGN-POINTER (&whole form
                                &key type address
				     static alignment
                                     &allow-other-keys)
  (when (or static alignment)
    (warn "LtoA: Ignoring :STATIC and :ALIGNMENT keywords in ~S" form))
  (unless (or address type)
    (warn "LtoA: :TYPE or :ADDRESS keyword required in ~S" form))
  `(MAKE-FOREIGN-POINTER-fun ,address ,type))

(defun MAKE-FOREIGN-POINTER-fun (address type)
  (if address
      address
    (if type
	(ff:malloc-cstruct (resolve-pointer-type type t))
      (error
       "LtoA: MAKE-FOREIGN-POINTER needs :TYPE or :ADDRESS argument."))))

(ff:def-c-type general-array 1000 :long)    ;; <17>

(defun MAKE-FOREIGN-POINTER-init (address type)
  (if address
      address
    (if type
	(let* ((st (resolve-pointer-type type t))
	       (ptr (ff:malloc-cstruct st)))
	  (when *INITIALIZE-FOREIGN-STRUCTS*
	    (dotimes (i (foreign-type-size st))
	      (setf (general-array ptr i) 0)))
	  ptr)
      (error
       "LtoA: MAKE-FOREIGN-POINTER needs :TYPE or :ADDRESS argument."))))

(defmacro MALLOC-FOREIGN-POINTER (&whole form &key type alignment)
  (when alignment
    (warn "LtoA: Ignoring :ALIGNMENT keyword in ~S" form))
  (unless type
    (warn "LtoA: :TYPE keyword is required in ~S" form))
  `(,(if *INITIALIZE-FOREIGN-STRUCTS*
	 'malloc-FOREIGN-POINTER-init
       'malloc-FOREIGN-POINTER-fun)
    ,type))

(defun MALLOC-FOREIGN-POINTER-fun (type)
  (ff:malloc-cstruct (resolve-pointer-type type t)))

(defun MALLOC-FOREIGN-POINTER-init (type)
  (let* ((st (resolve-pointer-type type t))
	 (ptr (ff:malloc-cstruct st)))
    (when *INITIALIZE-FOREIGN-STRUCTS*
      (dotimes (i (foreign-type-size st))
	(setf (general-array ptr i) 0)))
    ptr))

(defun FREE-FOREIGN-POINTER (x)
  (ff:free-cstruct x))

(defun COPY-FOREIGN-POINTER (x)
  (ltoa-warn "LCL:COPY-FOREIGN-POINTER")
  x)

(defmacro FOREIGN-AREF (&whole form foreign-vec &rest indices &aux tn)
  (if (and (consp foreign-vec)
           (setq tn (gethash (car foreign-vec) *known-pointer-accessors*))
	   (if (car tn)
	     ;; this is the array accessor for the pointed-to data
	     (setq tn (car tn))
	     (if (setq tn (find-name-of-type (second tn)))
	       ;; if the slot points to a named type, the name is the accessor
	       tn
	       nil))
	   )
      ;; If we recognize the extraction of an array slot, we can
      ;; identify the type of the array
      `(,tn ,foreign-vec ,@indices)
    (progn
      ;;Otherwise, can only cause a run-time error.
      ;; This also takes care of the SETF form
      (warn "LtoA: Use TYPED-FOREIGN-AREF instead of ~S" form)
      `(error "LtoA: calling FOREIGN-AREF ~S ~S"
              ,foreign-vec (list ,@indices)))))

(defmacro TYPED-FOREIGN-AREF (foreign-type foreign-vec &rest indices
                                                             &aux acc mod)
  (if (and (consp foreign-type)
           (eq 'quote (car foreign-type))
	   (progn
	     (multiple-value-setq (acc mod) 
	       (decode-array-accessor (second foreign-type)))
	     acc))
      ;; We can use this path when the foreign type is
      ;; explicitly specified and it has a corresponding accessor
      (if mod 
	  `(,mod (,acc ,foreign-vec ,@indices))
	`(,acc ,foreign-vec ,@indices))
    ;; If foreign-type is computed, we have to be more sneaky.
    `(TYPED-FOREIGN-AREF-fun ,foreign-type ,foreign-vec ,@indices)))

(defun TYPED-FOREIGN-AREF-fun (foreign-type foreign-vec &rest indices
                               &aux acc mod val)
  (multiple-value-setq (acc mod) (decode-array-accessor (second foreign-type)))
  (setq val (if acc
      (apply (symbol-function acc) foreign-vec indices)
    ;; We assume the foreign type is a name, and therefore happens to
    ;; be the necessary accessor.
      (apply (symbol-function foreign-type) foreign-vec indices)))
  (if mod (funcall (symbol-function mod) val) val))

(defsetf TYPED-FOREIGN-AREF-fun (foreign-type foreign-vec &rest indices) (val)
  `(TYPED-FOREIGN-AREF-set ,val ,foreign-type ,foreign-vec ,@indices))

(defun TYPED-FOREIGN-AREF-set (val foreign-type foreign-vec &rest indices
			       &aux acc mod)
  (multiple-value-setq (acc mod) (decode-array-accessor (second foreign-type)))
  (when acc
      (setq foreign-type acc))
  ;; We assume the foreign type is a name, and therefore happens to
  ;; be the necessary accessor.
  (eval `(setf (,foreign-type ,foreign-vec ,@indices)
	   ,(if mod (list mod val) val))))

(defmacro FOREIGN-STRING-VALUE (foreign-pointer &optional (length nil l-p) &aux tn def)
  (if (and (null l-p)
           (consp foreign-pointer)
           (setq tn (gethash (car foreign-pointer) *known-pointer-accessors*))
           (setq def (second tn))
           (or (eq def :character)
               (and (consp def) (eq (car def) :array)
                    (eq (second def) :character))))
      ;; Since we can figure out the type of the foreign pointer
      ;; we can generate correct code.
      (if (eq def :character)
          `(FOREIGN-STRING-VALUE-fun ,foreign-pointer nil)
        `(FOREIGN-STRING-VALUE-fun ,foreign-pointer ,(car (third def))))
    (progn
      (unless l-p
        (warn "LtoA: FOREIGN-STRING-VALUE needs a length/type argument."))
      `(FOREIGN-STRING-VALUE-fun ,foreign-pointer ,@(when l-p (list length))))))

(ff:def-c-type charray 1000000 :char)

(defun foreign-string-value-inner (x)
  (foreign-string-value-fun x nil))

(defun foreign-string-value-fun (foreign-pointer &optional (length nil l-p))
  (unless l-p
    (error "LtoA: FOREIGN-STRING-VALUE needs a length arguments."))
  (unless (foreign-pointer-p foreign-pointer)
    (error ":LtoA Bad foreign pointer"))
  (when (eql foreign-pointer 0)
    ;; this seems to be a special case in LCL
    (return-from foreign-string-value-fun nil))
  (when (symbolp length) (setq length (expand-foreign-type length)))
  (when (consp length)
    (when (eq :pointer (car length)) (setq length (second length)))
    (if (eq length :character)
        (setq length nil)
      (if (and (consp length) (eq :array (car length))
               (eq :character (second length)))
          (setq length (car (third length)))
        (error "LtoA: Bad length argument."))))
  (if (null length)
      (ff:char*-to-string foreign-pointer)
    (let ((string (make-sequence 'string length)))
      (dotimes (i length)
        (setf (elt string i)
          (int-char (charray foreign-pointer i))))
      string)))

(defsetf FOREIGN-STRING-VALUE-fun (foreign-pointer &rest length) (val)
  `(FOREIGN-STRING-VALUE-set ,val ,foreign-pointer ,@length))

(defun FOREIGN-STRING-VALUE-set (val foreign-pointer
                                 &optional (length nil l-p))
  (unless l-p
    (error "LtoA: FOREIGN-STRING-VALUE needs a length arguments."))
  (unless (foreign-pointer-p foreign-pointer)
    (error "LtoA: Bad foreign pointer"))
  (check-type val string)
  (dotimes (i (or length (length val)))
    (setf (charray foreign-pointer i) (char-int (elt val i))))
  (unless length
    (setf (charray foreign-pointer (length val)) 0))
  val)


(defvar *SAFER-CODE* t)

(defmacro FOREIGN-VALUE (x &optional type)
  (let* ((wrapper nil)
	 (acc
	  (case type
	    ((:char :character)
	     (setq wrapper 'int-char)
	     'callback-char-place)
	    ((nil :long) 
	     (unless type
	       (warn "LtoA: FOREIGN-VALUE defaulting to :LONG."))
	     'callback-long-place)
	     (:single-float 'callback-single-place)
	     (:double-float 'callback-double-place)
	     (otherwise (warn "LtoA: Unknown type ~S in FOREIGN-VALUE." type)))))
    (if *safer-code*
      `(foreign-value-fn #',acc ,x ',type)
      (if wrapper
	`(,wrapper (,acc ,x))
	`(,acc ,x)))))

(defun foreign-value-fn (acc ptr type)
  (let ((v (funcall acc ptr)))
    (if (eq type :char)
      (int-char v)
      v)))

(defsetf foreign-value-fn (acc ptr type) (val) 
  `(set-foreign-value-fn ,acc ,ptr ,type ,val))

(defun set-foreign-value-fn (acc ptr type val)
  (declare (ignore acc))
  (case type
    ((:char :character) (setf (callback-char-place ptr) (char-int val)))
    ((nil :long) (setf (callback-long-place ptr) (coerce val 'fixnum)))
    (:single-float (setf (callback-single-place ptr) 
		     (coerce val 'single-float)))
    (:double-float (setf (callback-double-place ptr) 
		     (coerce val 'double-float)))
    (otherwise (error "LtoA: Unknown FOREIGN-VALUE type ~S" type))))




(defun FOREIGN-VARIABLE-P (string)
  (when (ff:get-entry-point string) t))

(defun FOREIGN-VARIABLE-ADDRESS (string)
  (ff:get-entry-point string))

(defun FOREIGN-VARIABLE-POINTER (string)
  (ff:get-entry-point string))

(defun STATIONARY-OBJECT-P (x)
  (or (foreign-pointer-p x)
      (eq :static (sys:pointer-storage-type x))))

(defun WRITABLE-OBJECT-P (x)
  (or (foreign-pointer-p x)
      (not (eq :immediate (sys:pointer-storage-type x)))))

(defun UNINTERN-FOREIGN-SYMBOL (x)
  (ff:remove-entry-point x))

(defun RUN-PROGRAM (name &key input output error-output
                              wait arguments if-input-does-not-exist
                              if-output-exists if-error-output-exists
                              )
  (let (iostream errstream process)
    (multiple-value-setq (iostream errstream process)
      (excl:run-shell-command
       (apply #'concatenate 'string
              name " "
              (mapcan #'(lambda (x) (list x " ")) arguments))
       :input input
       :output output
       :error-output error-output
       :wait wait
       :if-input-does-not-exist if-input-does-not-exist
       :if-output-exists if-output-exists
       :if-error-output-exists if-error-output-exists
       ))
    (values iostream errstream (if wait 0 nil) process))
  )

(defun environment-variable (name)
  (system:getenv name))

(defun pwd ()
  (excl:current-directory))

(defun working-directory ()
  (excl:current-directory))

(defun cd (&optional directory)
  (if directory
      (excl:chdir directory)
    (excl:chdir)))

(defstruct resource-internal
  name
  objects
  constructor 
  initialization-function
  cleanup-function 
  )

(defun CLEAR-RESOURCE (resource)
  (setf (resource-internal-objects  resource) nil))

(defun MAKE-RESOURCE (name &key constructor initial-copies 
                                initialization-function
                                cleanup-function initial-args
				filter-function)
  (declare (ignore filter-function))
  (let ((resource
         (make-resource-internal 
          :name name
          :constructor constructor
          :initialization-function initialization-function
          :cleanup-function cleanup-function)))
    (dotimes (i (or initial-copies 0))
      (push (apply constructor initial-args)
            (resource-internal-objects resource)))
    resource))

(defun RESOURCE-ALLOCATE (resource &rest args)
  (let ((old (resource-internal-objects resource)))
    (if old
	(let ((init (resource-internal-initialization-function resource)))
	  (setf (resource-internal-objects resource) (cdr old))
	  (when init (apply init (car old) args))
	  (car old))
      (let ((constructor (resource-internal-constructor resource)))
	(apply constructor args))
      )))

(defun RESOURCE-DEALLOCATE (resource object)
  (let ((fn (resource-internal-cleanup-function resource)))
    (when fn (funcall fn object))
    (push object (resource-internal-objects resource))
    nil))

(defmacro USING-RESOURCE ((obvar resource &rest args) &body body)
  (let ((resvar (gensym)) 
	(argvars (mapcar #'(lambda (x) (declare (ignore x)) (gensym)) args)))
    `(let ((,resvar ,resource) 
	   ,@(mapcar #'(lambda (v a) (list v a))
		     argvars args)
	   ,obvar)
     (unwind-protect
	 (progn
	   (setq ,obvar (resource-allocate ,resvar ,@argvars))
	   ,@body)
       (when ,obvar (resource-deallocate ,resvar ,obvar))))))



;; A handy macro to generate efficient references to single-float
;;   arrays when double-float is needed.

(defmacro AREF-SF (&rest args) `(coerce (aref ,@args) 'double-float))

(defsetf AREF-SF (a &rest is) (v)
  `(setf (aref ,a ,@is) (coerce ,v 'single-float)))


;; A macro to allow arefs to foreign arrays with dynamically
;;   varying dimensions

(defmacro VAR-FOREIGN-AREF (vector-type dimensions array &rest indices)
  `(apply #',vector-type ,array 
	  (compute-vector-index 0 ,dimensions ,@indices)))

(defun compute-vector-index (p rest &rest ix)
  (if (atom rest)
      p
    (apply #'compute-vector-index
	   (+ (first ix) (* p (first rest)))
	   (cdr rest)
	   (cdr ix))))