;; $Id: update.cl,v 1.1 1998/02/21 02:01:03 layer Exp $

(progn
  (format t "~%~%
When \"Done\" prints after building new images, exit the Lisp.~%~%")

  (dolist (dxl-file (directory "*.dxl"))
    (let ((file (file-namestring dxl-file))
	  (dxl-file (namestring dxl-file)))
      (if* (or (string-equal "update.dxl" file)
	       (match-regexp ".*orig\\.dxl$" file)
	       (match-regexp ".*old\\.dxl$" file))
	 thenret ;; ignore these files
	 else (format t "Making new ~a...~%" file)
	      (let ((orig-dxl (format nil "~aorig.dxl" (pathname-name file)))
		    (old-dxl (format nil "~aold.dxl" (pathname-name file)))
		    (lisp-exe (if* (match-regexp ".*i\\.dxl$" dxl-file)
				 then "lispi"
				 else "lisp")))
		(if* (not (probe-file orig-dxl))
		   then (rename-file dxl-file orig-dxl)
		 elseif (not (probe-file old-dxl))
		   then (rename-file dxl-file old-dxl))
		(with-open-file (s "update1.cl" :direction :output
				 :if-exists :supersede)
		  (format s "(build-lisp-image \"~a\")~%" file)
		  (format s "(exit 0)~%"))
		(run-shell-command
		 (format
		  nil
		  "~a +s update1.cl -I ~a -qq -batch -backtrace-on-error"
		  lisp-exe orig-dxl))
		(delete-file "update1.cl")
		(when (not (probe-file file))
		  (error "Build of ~a failed." file))))))

  (format t "Done.~%"))
