#! /bin/sh
# $Id: update.sh,v 1.1 1998/02/21 02:01:04 layer Exp $
#
# Run ./update.sh to rebuild all your images to include patches.

for image in *.dxl; do
	case $image in
	*-old.dxl|*-orig.dxl) continue
		;;
	*i.dxl) lisp=lispi
		;;
	*) lisp=lisp
		;;
	esac

	if test ! -f $lisp; then
		echo "Sorry, $lisp does not exist."
		exit 1
	fi

	orig_image="`echo ${image} | sed 's/.dxl//'`-orig.dxl"
	old_image="`echo ${image} | sed 's/.dxl//'`-old.dxl"

	if test ! -f $orig_image; then
		mv $image $orig_image
		chmod a-w $orig_image
	fi
	if test -f $image; then
		mv $image $old_image
	fi

	cat << EOF | ./$lisp -I $orig_image -qq -batch -backtrace-on-error
(build-lisp-image "$image")
(exit 0)
EOF
done
